## mcrl2 201210.1

=== CMakeLists.txt ===
# Authors: Frank Stappers and Aad Mathijssen
# Copyright: see the accompanying file COPYING or copy at
# https://svn.win.tue.nl/trac/MCRL2/browser/trunk/COPYING
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

cmake_minimum_required (VERSION 2.8)
project (MCRL2)
# Commonly used options
# ---------------------
#
# The following lists some commonly used options to configure the build system
# (an option name following by (*) indicates the default option):
#
#   CMAKE_INSTALL_PREFIX = /usr/local(*) (any path can be used)
#   CMAKE_BUILD_TYPE     = None | Debug | Release(*) | RelwithDebInfo | MinSizeRel
#   BUILD_SHARED_LIBS    = ON    | OFF(*)

option(MCRL2_ENABLE_GUI_TOOLS
       "Enable/disable creation of GUI tools"          ON)
option(MCRL2_ENABLE_CADP_SUPPORT
       "Enable/disable support for CADP"               OFF)
option(MCRL2_ENABLE_EXPERIMENTAL
       "Enable/disable creation of experimental tools" OFF)
option(MCRL2_ENABLE_DEPRECATED
       "Enable/disable creation of deprecated tools"   OFF)
option(MCRL2_INSTALL_HEADERS
       "Enable/disable install headers"                ON)

# Note on adding definitions containing quotes (")
# ------------------------------------------------
#
# Compiler definitions can be added to CMake using the ADD_DEFINITIONS command
# or COMPILE_DEFINITIONS property. Be careful when adding a definition that
# contains quotes ("), as CMake cannot guarantee the generation of platform
# independent scripts. Typically these definitions are of the form FOO="bar",
# which can be added as follows:
#
#   add_definitions(-DFOO="bar")
#
# From this, CMake is able to generate correct Makefiles. However, CMake is
# not able to generate a correct Eclipse CDT4 project.
#
# The solution that is currently employed is by adding compiler definitions
# that contain quotes using the set_source_files_properties command with the
# the COMPILE_DEFINITIONS property:
#
#   set_source_files_properties(baz.cpp
#     PROPERTIES COMPILE_DEFINITIONS FOO="bar"
#   )
#
# This way, these compiler definitions are not included in the Eclipse CDT4
# project file, circumventing the problem.
#
# When this solution cannot be applied, there is another workaround: by quoting
# the entire compiling definition it is prevented from being incorporated in
# the Eclipse CDT4 project:
#
#   add_definitions(-D"FOO=\\"bar\\"")
#
# However, the best solution is to avoid the need for these quotes in the
# first place. This is mentioned as a disclaimer in the CMake 2.6 documentation
# for the COMPILER_DEFINITIONS property:
#
#   Dislaimer: Most native build tools have poor support for escaping
#   certain values. CMake has work-arounds for many cases but some values
#   may just not be possible to pass correctly. If a value does not seem to
#   be escaped correctly, do not attempt to work-around the problem by
#   adding escape sequences to the value. Your work-around may break in a
#   future version of CMake that has improved escape support. Instead
#   consider defining the macro in a (configured) header file. Then report
#   the limitation.
#
# The disclaimer with some additional information can be found here:
#
#   http://www.cmake.org/cmake/help/cmake2.6docs.html#prop_dir:COMPILE_DEFINITIONS
#

##---------------------------------------------------
## Configure CMake
##---------------------------------------------------

## Set path where additional modules can be found
set( CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/scripts" )

## Determine build type
if(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)

## Library and executable staging
set(MCRL2_STAGE_ROOTDIR ""
  CACHE PATH "Path to stage executables and libraries." )
  message( STATUS "MCRL2_STAGE_ROOTDIR: ${MCRL2_STAGE_ROOTDIR}" )
if( MCRL2_STAGE_ROOTDIR )
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${MCRL2_STAGE_ROOTDIR}/bin")
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${MCRL2_STAGE_ROOTDIR}/lib")
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${MCRL2_STAGE_ROOTDIR}/share/mcrl2")
endif( MCRL2_STAGE_ROOTDIR )

## Set runtime path variable RPATH for install targets

# use, i.e. don't skip the full RPATH for the build tree
set(CMAKE_SKIP_BUILD_RPATH false)

# when building, don't use the install RPATH already
# (but later on when installing)
set(CMAKE_BUILD_WITH_INSTALL_RPATH false)

# the RPATH to be used when installing (non-OSX, use CMAKE_INSTALL_NAME_DIR instead)
if(NOT CMAKE_INSTALL_RPATH)
  set(CMAKE_INSTALL_RPATH "$ORIGIN/../lib/mcrl2")
endif(NOT CMAKE_INSTALL_RPATH)

# Mac OSX directory name for installed targets
# Installing prerequisite shared libraries is dealt with in "RelocateInstallTree.cmake"
set(CMAKE_INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib/mcrl2")

# add the automatically determined parts of the RPATH
# which point to directories outside the build tree to the install RPATH
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH true)

## Configure the compiler
include(GetCompilerVersion)
include(ConfigureCompiler)

## Setup dependency to CADP
include(MCRL2CADPSupport)

## Determine latest SVN revision
include(MCRL2Version)

##---------------------------------------------------
## Print additional configuration information
##---------------------------------------------------
include(PrintBuildInfo)

##---------------------------------------------------
## Find dependencies (Boost, OpenGL, [CVC3, gl2ps])
##---------------------------------------------------
include(ConfigureBoost)
find_package(cvc3)

if( MCRL2_ENABLE_GUI_TOOLS )
  find_package(OpenGL)
  find_package(gl2ps)

  if(NOT OPENGL_FOUND)
    message( FATAL_ERROR "OpenGL not found. Set MCRL2_ENABLE_GUI_TOOLS to FALSE to build without GUI-tools.")
  else( OPENGL_FOUND )
    if ( APPLE )
      include_directories( ${OPENGL_INCLUDE_DIR} )
      link_directories(${OPENGL_LIBRARIES})
      set(CMAKE_EXE_LINKER_FLAGS "-framework OpenGL ${CMAKE_EXE_LINKER_FLAGS}")
      set(CMAKE_SHARED_LINKER_FLAGS "-framework OpenGL ${CMAKE_SHARED_LINKER_FLAGS}")
      set(CMAKE_MODULE_LINKER_FLAGS "-framework OpenGL ${CMAKE_SHARED_LINKER_FLAGS}")
    endif (APPLE)
  endif(NOT OPENGL_FOUND)

  find_package(Qt4 COMPONENTS QtCore QtGui QtXml QtOpenGL)
  if(QT4_FOUND)
    include(${QT_USE_FILE})
  else(QT4_FOUND)
    message(FATAL_ERROR "Qt4 not found. Set MCRL2_ENABLE_GUI_TOOLS to FALSE to build without GUI-tools.")
  endif(QT4_FOUND)

  message(STATUS "QT Version: ${QT_VERSION_MAJOR}.${QT_VERSION_MINOR}.${QT_VERSION_PATCH}")

endif( MCRL2_ENABLE_GUI_TOOLS )

##---------------------------------------------------
## 3rd party libraries
##---------------------------------------------------

if(MCRL2_ENABLE_GUI_TOOLS)
  add_subdirectory ( 3rd-party/tr)
  if( GL2PS_FOUND )
    message(STATUS "Using system gl2ps library.")
  else( GL2PS_FOUND )
    message(STATUS "Using gl2ps library provided by mCRL2.")
    add_subdirectory ( 3rd-party/gl2ps )
  endif( GL2PS_FOUND)
endif(MCRL2_ENABLE_GUI_TOOLS)

add_subdirectory ( 3rd-party/svc )
add_subdirectory ( 3rd-party/dparser )

##---------------------------------------------------
## mCRL2 libraries
##---------------------------------------------------

add_subdirectory ( libraries/aterm )
add_subdirectory ( libraries/atermpp )
add_subdirectory ( libraries/bes )
add_subdirectory ( libraries/core )
add_subdirectory ( libraries/data )
add_subdirectory ( libraries/lps )
add_subdirectory ( libraries/lts )
add_subdirectory ( libraries/pbes )
add_subdirectory ( libraries/process )
add_subdirectory ( libraries/trace )
add_subdirectory ( libraries/utilities )

##---------------------------------------------------
## Command-line tools
##---------------------------------------------------

add_subdirectory ( tools/besinfo )
add_subdirectory ( tools/bespp )
add_subdirectory ( tools/complps2pbes )
add_subdirectory ( tools/formulacheck )
add_subdirectory ( tools/lps2lts )
add_subdirectory ( tools/lps2pbes )
add_subdirectory ( tools/lps2torx )
add_subdirectory ( tools/lpsactionrename )
add_subdirectory ( tools/lpsbinary )
add_subdirectory ( tools/lpsconfcheck )
add_subdirectory ( tools/lpsconstelm )
add_subdirectory ( tools/lpsinfo )
add_subdirectory ( tools/lpsinvelm )
add_subdirectory ( tools/lpsparelm )
add_subdirectory ( tools/lpsparunfold )
add_subdirectory ( tools/lpspp )
add_subdirectory ( tools/lpsrewr )
add_subdirectory ( tools/lpssumelm )
add_subdirectory ( tools/lpssuminst )
add_subdirectory ( tools/lpsuntime )
add_subdirectory ( tools/lpssim )
add_subdirectory ( tools/lts2lps )
add_subdirectory ( tools/lts2pbes )
add_subdirectory ( tools/ltsconvert )
add_subdirectory ( tools/ltscompare )
add_subdirectory ( tools/ltsinfo )
add_subdirectory ( tools/mcrl22lps )
add_subdirectory ( tools/mcrl2i )
add_subdirectory ( tools/mcrl2parse )
add_subdirectory ( tools/pbes2bool )
add_subdirectory ( tools/pbes2bes )
add_subdirectory ( tools/pbesconstelm )
add_subdirectory ( tools/pbesinfo )
add_subdirectory ( tools/pbesparelm )
add_subdirectory ( tools/pbespgsolve )
add_subdirectory ( tools/pbespp )
add_subdirectory ( tools/pbesrewr )
add_subdirectory ( tools/symbolic_exploration )
add_subdirectory ( tools/tbf2lps )
add_subdirectory ( tools/tracepp )
add_subdirectory ( tools/txt2pbes )
add_subdirectory ( tools/txt2lps )

##---------------------------------------------------
## Graphical tools
##---------------------------------------------------
if(MCRL2_ENABLE_GUI_TOOLS)
  add_subdirectory ( tools/diagraphica )
  add_subdirectory ( tools/lpsxsim )
  add_subdirectory ( tools/ltsgraph )
  add_subdirectory ( tools/ltsview )
  add_subdirectory ( tools/mcrl2-gui )
  add_subdirectory ( tools/mcrl2xi )
endif(MCRL2_ENABLE_GUI_TOOLS)

##---------------------------------------------------
## Experimental tools
##---------------------------------------------------

if(MCRL2_ENABLE_EXPERIMENTAL)
  add_subdirectory ( tools/besconvert )
  add_subdirectory ( tools/bessolve )
  add_subdirectory ( tools/lpsbisim2pbes )
  add_subdirectory ( tools/lpsrealelm )
  add_subdirectory ( tools/pbesabstract )
  add_subdirectory ( tools/pbesabsinthe )
  add_subdirectory ( tools/pbesinst )
  add_subdirectory ( tools/pbespareqelm )
  add_subdirectory ( tools/txt2bes )
endif(MCRL2_ENABLE_EXPERIMENTAL)

##---------------------------------------------------
## Deprecated tools
##---------------------------------------------------

if(MCRL2_ENABLE_DEPRECATED)

endif(MCRL2_ENABLE_DEPRECATED)

##---------------------------------------------------
## Helper for exporting symbolic links on OS-X
##---------------------------------------------------

if(APPLE AND MCRL2_SINGLE_BUNDLE AND MCRL2_ENABLE_GUI_TOOLS)
  add_subdirectory( build/macosx )
endif(APPLE AND MCRL2_SINGLE_BUNDLE AND MCRL2_ENABLE_GUI_TOOLS)


##---------------------------------------------------
## Documentation
##---------------------------------------------------

# Documentation requires python
include(ConfigurePython)
# Documentation requires doxygen
include(ConfigureDoxygen)
# Documentation requires xsltproc
include(FindXsltproc)

if(PYTHONINTERP_FOUND)
  if ( MCRL2_PY_SPHINX )
    if ( MCRL2_PY_ARGPARSE )
      if( DOXYGEN_FOUND )
        if (XSLTPROC )
          add_subdirectory ( doc/sphinx )
        else( XSLTPROC )
          message( STATUS "Documentation cannot be generated: xsltproc is missing." )
        endif( XSLTPROC)
      else( DOXYGEN_FOUND )
        message( STATUS "Documentation cannot be generated: doxygen is missing." )
      endif( DOXYGEN_FOUND )
    else ( MCRL2_PY_ARGPARSE )
      message( STATUS "Documentation cannot be generated: Python argparse-module is missing." )
    endif( MCRL2_PY_ARGPARSE )
  else ( MCRL2_PY_SPHINX )
    message( STATUS "Documentation cannot be generated: Python sphinx-module is missing." )
  endif( MCRL2_PY_SPHINX )
elseif(PYTHONINTERP_FOUND)

=== 3rd-party/dparser/CMakeLists.txt ===
# Author: Sjoerd Cranen
# Copyright: see the accompanying file COPYING or copy at
# https://svn.win.tue.nl/trac/MCRL2/browser/trunk/COPYING
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

# ########## Project setup ##########
project(dparser)
cmake_minimum_required(VERSION 2.6)

add_definitions(
  -DD_MAJOR_VERSION=1
  -DD_MINOR_VERSION=26
  -DD_BUILD_VERSION="mCRL2"
  -DD_USE_FREELISTS=1
)

if(MSVC)
add_definitions(
  -Dstrtoll=_strtoi64
  -Dstrncasecmp=_strnicmp
  -Dsnprintf=_snprintf
)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /w")
else(MSVC)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -w")
   # The following is more accurate, but currently does not do the job
  #set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-sign-compare -Wno-unused-parameter -Wno-long-long -Wno-format")
endif(MSVC)

# ######### General setup ##########
include_directories(${CMAKE_SOURCE_DIR}/3rd-party/dparser)

# actual target:
add_library(dparser
  arg.c
  parse.c
  scan.c
  symtab.c
  util.c
  read_binary.c
  dparse_tree.c
)

add_executable(make_dparser
  make_dparser.c
  version.c
  mkdparse.c
  write_tables.c
  grammar.g.c
  gram.c
  lex.c
  lr.c
)

target_link_libraries(make_dparser
  dparser
)

install(TARGETS dparser DESTINATION ${MCRL2_LIB_DIR} COMPONENT Libraries)

=== 3rd-party/svc/CMakeLists.txt ===
# Authors: Frank Stappers and Aad Mathijssen
# Copyright: see the accompanying file COPYING or copy at
# https://svn.win.tue.nl/trac/MCRL2/browser/trunk/COPYING
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

# ########## Project setup ##########
project(svc)
cmake_minimum_required(VERSION 2.6)

# ######### General setup ##########

# actual target:
add_library(${PROJECT_NAME}
  source/huffman.cpp
  source/lz.cpp
  source/compress.cpp
  source/blocklist.cpp
  source/code.cpp
  source/ptable.cpp
  source/svc1.cpp
  source/svc2.cpp
  source/hashtable.cpp
)

include_directories(${CMAKE_SOURCE_DIR}/3rd-party/svc/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/aterm/include)

target_link_libraries(${PROJECT_NAME}
  mcrl2_aterm
)

# add install target:
install(TARGETS ${PROJECT_NAME} DESTINATION ${MCRL2_LIB_DIR} COMPONENT Libraries)

=== 3rd-party/tr/CMakeLists.txt ===
# Authors: Frank Stappers and Aad Mathijssen
# Copyright: see the accompanying file COPYING or copy at
# https://svn.win.tue.nl/trac/MCRL2/browser/trunk/COPYING
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

# ########## Project setup ##########
project(tr)
cmake_minimum_required(VERSION 2.6)

# ######### General setup ##########

# Trick to add header files to projects in IDEs like Visual Studio and XCode
FILE(GLOB HEADERS "include/tr/*.h")
add_custom_target(${PROJECT_NAME}_headers
  SOURCES ${HEADERS} ${DETAIL_HEADERS}
)

# actual target:
add_library(${PROJECT_NAME}
  source/tr.c
)

target_link_libraries(${PROJECT_NAME}
  ${OPENGL_LIBRARY}
)

include_directories(${CMAKE_SOURCE_DIR}/3rd-party/tr/include/tr)

# add install target:
install(TARGETS ${PROJECT_NAME} DESTINATION ${MCRL2_LIB_DIR} COMPONENT Libraries)

=== build/macosx/CMakeLists.txt ===
# Authors: Frank Stappers
# Copyright: see the accompanying file COPYING or copy at
# https://svn.win.tue.nl/trac/MCRL2/browser/trunk/COPYING
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

# ########## Project setup ##########
project(mac_installer)
cmake_minimum_required(VERSION 2.8)


# ########## Create MacOSX Bundle Information ######### 
include(MCRL2MacOSXBundleInformation)
# overrule default MACOSX_BUNDLE_ICON_FILE location
SET(MACOSX_BUNDLE_ICON_FILE mcrl2-logo.icns)

# ######### General setup ##########
set(MAC_INSTALLER_UI_FILES
  mac_installer.ui
)
qt4_wrap_ui(MAC_INSTALLER_UI_HEADERS ${MAC_INSTALLER_UI_FILES})

set(MAC_INSTALLER_MOC_HEADERS
  mac_installer.h
)
qt4_wrap_cpp(MAC_INSTALLER_MOC_SOURCES ${MAC_INSTALLER_MOC_HEADERS})

set(MAC_INSTALLER_SRC_FILES
  ${MAC_INSTALLER_RC_FILES}
  ${MAC_INSTALLER_UI_HEADERS}
  ${MAC_INSTALLER_MOC_SOURCES}
  mac_installer.cpp
)

if ( MCRL2_ENABLE_GUI_TOOLS )
add_executable(${PROJECT_NAME} WIN32 MACOSX_BUNDLE
  ${MAC_INSTALLER_SRC_FILES}
  ${MACOSX_BUNDLE_ICON_FILE}
)

IF (APPLE)
 SET_SOURCE_FILES_PROPERTIES(${MACOSX_BUNDLE_ICON_FILE} PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
ENDIF (APPLE)


# Don't forget to include output directory, otherwise
# the UI file won't be wrapped!
include_directories(${CMAKE_CURRENT_BINARY_DIR})
# For promoted widgets
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

target_link_libraries(${PROJECT_NAME}
    ${QT_LIBRARIES}
)

# install target:
install(TARGETS ${PROJECT_NAME} DESTINATION ${MCRL2_BIN_DIR})

else ( MCRL2_ENABLE_GUI_TOOLS )
  message( STATUS "MCRL2_BUILD_GUI_TOOLS needs to be set to TRUE to create installer")
endif ( MCRL2_ENABLE_GUI_TOOLS )

=== build/testing/CMakeLists.txt ===
# Authors: Frank Stappers 
# Copyright: see the accompanying file COPYING or copy at
# https://svn.win.tue.nl/trac/MCRL2/browser/trunk/COPYING
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

# This script tries to compile all header files "*.h" 
# in the libraries directories. The script is only 

# ########## Project setup ##########
project(mcrl2_headertest_targets)
cmake_minimum_required(VERSION 2.6)

set(MRCL2_HEADERTESTS_INCLUDE_DIRECTORIES
  ${CMAKE_SOURCE_DIR}/libraries/aterm/include/
  ${CMAKE_SOURCE_DIR}/libraries/lps/include
  ${CMAKE_SOURCE_DIR}/libraries/bes/include
  ${CMAKE_SOURCE_DIR}/libraries/pbes/include
  ${CMAKE_SOURCE_DIR}/libraries/data/include
  ${CMAKE_SOURCE_DIR}/libraries/core/include/ 
  ${CMAKE_SOURCE_DIR}/libraries/utilities/include 
  ${CMAKE_SOURCE_DIR}/libraries/process/include/
  ${CMAKE_SOURCE_DIR}/libraries/atermpp/include
  ${CMAKE_SOURCE_DIR}/build/workarounds/
  ${CMAKE_SOURCE_DIR}/build/precompile
  ${CMAKE_SOURCE_DIR}/libraries/lts/include
  ${CMAKE_SOURCE_DIR}/libraries/fdr/include
  ${CMAKE_SOURCE_DIR}/libraries/trace/include
  ${CMAKE_SOURCE_DIR}/libraries/utilities/include
  ${CMAKE_SOURCE_DIR}/3rd-party/gl2ps
  ${CMAKE_SOURCE_DIR}/3rd-party/svc
  ${CMAKE_SOURCE_DIR}/3rd-party/tr
)

set(MRCL2_HEADERTESTS_INCLUDE_DIRECTORIES
  ${MRCL2_HEADERTESTS_INCLUDE_DIRECTORIES}
  ${Boost_INCLUDE_DIRS}
)

include_directories( ${MRCL2_HEADERTESTS_INCLUDE_DIRECTORIES} )

file(GLOB_RECURSE TERM_OBJS "${CMAKE_SOURCE_DIR}/libraries/*.h")
foreach( OBJ ${TERM_OBJS} )

  file(RELATIVE_PATH X "${CMAKE_SOURCE_DIR}/libraries/" "${OBJ}")
  file(TO_CMAKE_PATH "${X}" Y )
  string(REPLACE "/" "_" Z "${Y}")
  string(REPLACE "." "_" result "${Z}")

  project( "header_${result}" )
  add_executable("header_${result}" EXCLUDE_FROM_ALL "header_test.cpp" )

  set_target_properties( "header_${result}"
  PROPERTIES COMPILE_DEFINITIONS "BOOST_UNITS_HEADER_NAME=${OBJ}" )

  add_test(NAME "header_${result}" 
    COMMAND ${CMAKE_MAKE_PROGRAM} "header_${result}" 
  )


endforeach( OBJ )

=== doc/sphinx/CMakeLists.txt ===
# Authors: Jeroen Keiren
# Copyright: see the accompanying file COPYING or copy at
# https://svn.win.tue.nl/trac/MCRL2/browser/trunk/COPYING
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

# This script generates toolset documentation

configure_file( "${CMAKE_CURRENT_SOURCE_DIR}/source/user_manual/downloads-nightly.inc.template" "${CMAKE_CURRENT_SOURCE_DIR}/source/user_manual/downloads-nightly.inc" @ONLY )

set( MCRL2_GENERATE_DOC_RELEASE_FLAG "" )
if(MCRL2_PACKAGE_RELEASE)
  set( MCRL2_GENERATE_DOC_RELEASE_FLAG "-r" )
endif(MCRL2_PACKAGE_RELEASE)

set( MCRL2_GENERATE_DOC_SCRIPT ${CMAKE_CURRENT_SOURCE_DIR}/generate.py )
set( MCRL2_GENERATE_DOC_COMMAND ${MCRL2_GENERATE_DOC_SCRIPT} ${MCRL2_GENERATE_DOC_RELEASE_FLAG} -v=${MCRL2_VERSION} --path=${CMAKE_RUNTIME_OUTPUT_DIRECTORY} --temp=${CMAKE_CURRENT_BINARY_DIR}/_temp --out=${CMAKE_CURRENT_BINARY_DIR}/html )

add_custom_target(doc
  ${MCRL2_GENERATE_DOC_COMMAND} -c
  COMMAND ${MCRL2_GENERATE_DOC_COMMAND}
  COMMENT "(Re)-generating mCRL2 documentation (regenerates all cached documentation)" VERBATIM
)

add_custom_target(fastdoc ${MCRL2_GENERATE_DOC_COMMAND}
  COMMENT "Generating mCRL2 documentation (does not regenerate cached PDF, manual pages and Doxygen documentation)" VERBATIM
)

=== libraries/aterm/CMakeLists.txt ===
# Authors: Frank Stappers and Aad Mathijssen
# Copyright: see the accompanying file COPYING or copy at
# https://svn.win.tue.nl/trac/MCRL2/browser/trunk/COPYING
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

project(mcrl2_aterm)
cmake_minimum_required(VERSION 2.6)

# Trick to add header files to projects in IDEs like Visual Studio and XCode
FILE(GLOB_RECURSE HEADERS "include" "*.h")
add_custom_target(${PROJECT_NAME}_headers
  SOURCES ${HEADERS}
)

# main target
add_library(${PROJECT_NAME}
  source/idmappings.cpp
  source/bafio.cpp
  source/memmgnt.cpp
  source/memory.cpp
  source/aterm.cpp
  source/hash.cpp
  source/list.cpp
  source/afun.cpp
  source/safio.cpp
  source/byteencoding.cpp
  source/byteio.cpp
  source/gc.cpp
  source/aterm_ext.cpp
)

include_directories(${CMAKE_SOURCE_DIR}/libraries/aterm/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/utilities/include)

target_link_libraries(mcrl2_aterm
  mcrl2_utilities
)

install(TARGETS ${PROJECT_NAME} DESTINATION ${MCRL2_LIB_DIR} COMPONENT Libraries)

=== libraries/atermpp/CMakeLists.txt ===
# Authors: Frank Stappers and Aad Mathijssen
# Copyright: see the accompanying file COPYING or copy at
# https://svn.win.tue.nl/trac/MCRL2/browser/trunk/COPYING
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

project(mcrl2_atermpp)
cmake_minimum_required(VERSION 2.6)

# Trick to add header files to projects in IDEs like Visual Studio and XCode
FILE(GLOB_RECURSE HEADERS "include" "*.h")
add_custom_target(${PROJECT_NAME}_headers
  SOURCES ${HEADERS} ${DETAIL_HEADERS}
)

=== libraries/bes/CMakeLists.txt ===
# Authors: Frank Stappers and Aad Mathijssen
# Copyright: see the accompanying file COPYING or copy at
# https://svn.win.tue.nl/trac/MCRL2/browser/trunk/COPYING
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

project(mcrl2_bes)
cmake_minimum_required(VERSION 2.6)

# Trick to add header files to projects in IDEs like Visual Studio and XCode
FILE(GLOB_RECURSE HEADERS "include" "*.h")
add_custom_target(${PROJECT_NAME}_headers SOURCES ${HEADERS}
)

# ##### Start generate parser tables ######

# Silence warnings while compiling generated C code (pg-syntax.c is the only
# C code in this library)
if(MSVC)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /w") # Disable all warnings
else(MSVC)
  if (CMAKE_C_COMPILER_ID STREQUAL "Clang")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -w") # Disable all warnings
  else (CMAKE_C_COMPILER_ID STREQUAL "Clang")
    # Assuming GCC: disable only the missing-field-initializer warning.
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-missing-field-initializers")
  endif (CMAKE_C_COMPILER_ID STREQUAL "Clang")
endif(MSVC)

add_custom_command(
  OUTPUT ${CMAKE_SOURCE_DIR}/libraries/bes/source/pg_syntax.c
  COMMAND make_dparser -A -H1 -ipg -o${CMAKE_CURRENT_SOURCE_DIR}/source/pg_syntax.c ${CMAKE_SOURCE_DIR}/doc/specs/pg-syntax.g
  DEPENDS make_dparser ${CMAKE_SOURCE_DIR}/doc/specs/pg-syntax.g
)

include_directories(
  ${CMAKE_SOURCE_DIR}/3rd-party/dparser
)

add_library(${PROJECT_NAME}
  source/pg_syntax.c
)

target_link_libraries(
  ${PROJECT_NAME}
  dparser
)

# add install target:
install(TARGETS ${PROJECT_NAME} DESTINATION ${MCRL2_LIB_DIR} COMPONENT Libraries)

# ##### End generate parser tables ######

#target_link_libraries(${PROJECT_NAME}
#  pg_syntax
#  dparser
#)

=== libraries/core/CMakeLists.txt ===
# Authors: Frank Stappers and Aad Mathijssen
# Copyright: see the accompanying file COPYING or copy at
# https://svn.win.tue.nl/trac/MCRL2/browser/trunk/COPYING
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

# ########## Project setup ##########
project(mcrl2_core)
cmake_minimum_required(VERSION 2.6)

# Trick to add header files to projects in IDEs like Visual Studio and XCode
FILE(GLOB_RECURSE HEADERS "include" "*.h")
add_custom_target(${PROJECT_NAME}_headers SOURCES ${HEADERS})

# ##### Generate parser tables ######

# Silence warnings while compiling generated C code (mcrl2_syntax.c is the only
# C code in this library)
if(MSVC)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /w") # Disable all warnings
else(MSVC)
  if (CMAKE_C_COMPILER_ID STREQUAL "Clang")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -w") # Disable all warnings
  else (CMAKE_C_COMPILER_ID STREQUAL "Clang")
    # Assuming GCC: disable only the missing-field-initializer warning.
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-missing-field-initializers")
  endif (CMAKE_C_COMPILER_ID STREQUAL "Clang")
endif(MSVC)

add_custom_command(
  OUTPUT ${CMAKE_SOURCE_DIR}/libraries/core/source/mcrl2_syntax.c
  COMMAND make_dparser -A -H1 -imcrl2 -o${CMAKE_CURRENT_SOURCE_DIR}/source/mcrl2_syntax.c ${CMAKE_SOURCE_DIR}/doc/specs/mcrl2-syntax.g
  DEPENDS make_dparser ${CMAKE_SOURCE_DIR}/doc/specs/mcrl2-syntax.g
)

include_directories(
  ${CMAKE_SOURCE_DIR}/3rd-party/dparser
)

add_library(mcrl2_syntax
  source/mcrl2_syntax.c
)

target_link_libraries(mcrl2_syntax
  dparser
)

# add install target:
install(TARGETS mcrl2_syntax DESTINATION ${MCRL2_LIB_DIR} COMPONENT Libraries)

# ######### Set policies ############

# ###################################
# "core" links to some transitive
# libraries for which the linker must
# search:
#   wxWidgets
# Therefore CMP0003 is set to NEW
# If not set, a BUILD_SHARED_LIB=TRUE
# combined with a wxWidgets build
# raises a warning
# ###################################

if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

# ######### General setup ##########

set(mcrl2_core_src
  ${CMAKE_CURRENT_SOURCE_DIR}/source/parse.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/core.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/struct_core.cpp
)

set(mcrl2_core_src ${mcrl2_core_src} PARENT_SCOPE)

include_directories(${CMAKE_SOURCE_DIR}/libraries/process/include )
include_directories(${CMAKE_SOURCE_DIR}/libraries/lps/include )
include_directories(${CMAKE_SOURCE_DIR}/libraries/core/include )
include_directories(${CMAKE_SOURCE_DIR}/libraries/data/include )
include_directories(${CMAKE_SOURCE_DIR}/libraries/aterm/include )
include_directories(${CMAKE_SOURCE_DIR}/libraries/atermpp/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/utilities/include)
include_directories(${CMAKE_SOURCE_DIR}/build/workarounds/)

# actual target:
add_library(${PROJECT_NAME}
  ${mcrl2_core_src}
)

target_link_libraries(${PROJECT_NAME}
  mcrl2_aterm
  mcrl2_utilities
  mcrl2_syntax
)


# add install target:
install(TARGETS ${PROJECT_NAME} DESTINATION ${MCRL2_LIB_DIR} COMPONENT Libraries)

=== libraries/data/CMakeLists.txt ===
# Authors: Frank Stappers and Aad Mathijssen
# Copyright: see the accompanying file COPYING or copy at
# https://svn.win.tue.nl/trac/MCRL2/browser/trunk/COPYING
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

# ########## Project setup ##########
project(mcrl2_data)
cmake_minimum_required(VERSION 2.6)

# Trick to add header files to projects in IDEs like Visual Studio and XCode
FILE(GLOB_RECURSE HEADERS "include" "*.h")
add_custom_target(${PROJECT_NAME}_headers SOURCES ${HEADERS})

# ######### General setup ##########

#jitty.c requires DL_LIBS
if(UNIX)
  LINK_LIBRARIES(${CMAKE_THREAD_LIBS} ${CMAKE_DL_LIBS})
  set(COMP_REWRITERS
   ${CMAKE_CURRENT_SOURCE_DIR}/source/detail/rewrite/jittyc.cpp
#   ${CMAKE_CURRENT_SOURCE_DIR}/source/detail/rewrite/innerc.cpp
  )
endif(UNIX)

set(mcrl2_data_src
 ${CMAKE_CURRENT_SOURCE_DIR}/source/data.cpp
 ${CMAKE_CURRENT_SOURCE_DIR}/source/data_specification.cpp
 ${CMAKE_CURRENT_SOURCE_DIR}/source/typecheck.cpp
 ${CMAKE_CURRENT_SOURCE_DIR}/source/detail/enumerate/enum_standard.cpp
 ${CMAKE_CURRENT_SOURCE_DIR}/source/detail/prover/smt_lib_solver.cpp

 ${CMAKE_CURRENT_SOURCE_DIR}/source/detail/rewrite/with_prover.cpp
 # ${CMAKE_CURRENT_SOURCE_DIR}/source/detail/rewrite/inner.cpp
 ${CMAKE_CURRENT_SOURCE_DIR}/source/detail/rewrite/jitty.cpp
 ${CMAKE_CURRENT_SOURCE_DIR}/source/detail/rewrite/rewrite.cpp
 ${COMP_REWRITERS}
)

set(mcrl2_data_src ${mcrl2_data_src} PARENT_SCOPE)

include_directories(${CMAKE_SOURCE_DIR}/libraries/lps/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/process/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/data/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/core/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/atermpp/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/utilities/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/aterm/include)
include_directories(${CMAKE_SOURCE_DIR}/3rd-party/dparser)

include_directories(${CMAKE_SOURCE_DIR}/build/precompile)

add_library(${PROJECT_NAME}
  ${mcrl2_data_src}
)

target_link_libraries(${PROJECT_NAME}
  mcrl2_core
  mcrl2_utilities
)

# add install target:
install(TARGETS ${PROJECT_NAME} DESTINATION ${MCRL2_LIB_DIR} COMPONENT Libraries)

=== debian/changelog ===
mcrl2 (201210.1-1ubuntu1) raring; urgency=low

  * Fix FTBFS on arm*: Disable GUI tools on arm* as they require
    QtOpenGL (GLES) and GL in the same binary.

 -- Felix Geyer <debfx@ubuntu.com>  Mon, 05 Nov 2012 13:50:03 +0100

mcrl2 (201210.1-1) unstable; urgency=low

  [ Jeroen Keiren ]
  * New upstream (bugfix) release.

 -- Jeroen Keiren <jkeiren@win.tue.nl>  Fri, 26 Oct 2012 07:50:49 +0200

=== debian/control ===
Source: mcrl2
Section: math
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Jeroen Keiren <jkeiren@win.tue.nl>
Uploaders: Paul van Tilburg <paulvt@debian.org>
Build-Depends: debhelper (>= 5), cmake, libboost-system-dev (>= 1.37), libglu1-mesa-dev (>= 7.0.1), libgl2ps-dev, qt4-qmake, libqtcore4, libqtgui4, libqt4-xml, libqt4-opengl, libqt4-dev, libqt4-opengl-dev
Standards-Version: 3.9.3
Homepage: http://www.mcrl2.org/
Vcs-Browser: https://svn.win.tue.nl/viewcvs/MCRL2/packaging/mcrl2/trunk/
Vcs-Svn: https://svn.win.tue.nl/repos/MCRL2/packaging/mcrl2/trunk/

Package: mcrl2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: formal specification language toolset
 mCRL2 stands for micro Common Representation Language 2.  It is a
 specification language that can be used to specify and analyse the
 behaviour of distributed systems and protocols and is the successor to
 muCRL.  Using its accompanying toolset, systems can be analysed and
 verified automatically.
 .
 This toolset supports a collection of tools for linearisation, simulation,
 state-space exploration and generation and tools to optimise and analyse
 specifications.  Moreover, state spaces can be manipulated, visualised and
 analysed.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#
# Makefile to build the mCRL2 package using debhelper.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

CFLAGS = -Wall
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS_RELEASE = -O0 -g -DNDEBUG $(CFLAGS)
	CFLAGS_DEBUG   = -O0 -g $(CFLAGS)
else 
	CFLAGS_RELEASE = -O2 -g -DNDEBUG $(CFLAGS)
	CFLAGS_DEBUG   = -O2 -g $(CFLAGS)
endif

BUILD_TYPE = Release
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	BUILD_TYPE = Debug
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))  
    MAKEFLAGS += -j$(NUMJOBS)
endif

BUILD_FLAGS = -DCMAKE_INSTALL_PREFIX="/usr" \
              -DCMAKE_INSTALL_RPATH="/usr/lib/mcrl2" \
	      -DCMAKE_BUILD_TYPE="$(BUILD_TYPE)" \
	      -DCMAKE_C_FLAGS_RELEASE="$(CFLAGS_RELEASE)" \
	      -DCMAKE_VERBOSE_MAKEFILE="ON" \
	      -DMCRL2_ENABLE_EXPERIMENTAL="OFF" \
	      -DMCRL2_ENABLE_DEPRECATED="OFF"	 \
	      -DMCRL2_ENABLE_TEST_TARGETS="OFF" \
	      -DMCRL2_MAN_PAGES="ON" \
	      -DMCRL2_PACKAGE_RELEASE="ON"
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
	BUILD_FLAGS += -DCMAKE_SYSTEM_NAME=$(shell dpkg-architecture -qDEB_BUILD_ARCH_OS) \
		       -DCMAKE_SYSTEM_PROCESSOR=$(shell dpkg-architecture -qDEB_BUILD_ARCH_CPU) \
		       -DCMAKE_C_COMPILER=$(DEB_BUILD_GNU_TYPE)-gcc
endif
ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), armel armhf))
	BUILD_FLAGS += -DMCRL2_ENABLE_GUI_TOOLS="OFF"
endif

SRC	:= $(CURDIR)
BUILD	:= $(CURDIR)/debian/build
TARGET	:= $(CURDIR)/debian/mcrl2

configure: configure-stamp

configure-stamp:
	dh_testdir
	[ -d $(BUILD) ] || mkdir $(BUILD)
	cd $(BUILD) && \
	  cmake $(BUILD_FLAGS) $(CURDIR) 
	touch $@

build: build-arch build-indep

build-arch: build-stamp

build-indep: build-stamp

build-stamp: configure
	dh_testdir
	$(MAKE) -C $(BUILD) $(MAKEFLAGS)
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -rf $(BUILD)
	rm -f configure-stamp build-stamp 
	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs
	$(MAKE) -C $(BUILD) install DESTDIR=$(TARGET)
	# Generate and install the man pages.
	export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:$(BUILD)/usr/lib/mcrl2
	$(MAKE) -C $(BUILD) $(MAKEFLAGS)
	$(MAKE) -C $(BUILD) install DESTDIR=$(TARGET)

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installexamples
	dh_installmenu
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_makeshlibs -V --exclude=/usr/lib/mcrl2
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build build-arch build-indexp clean binary-indep binary-arch binary install
